/*
	MyDrawView.cpp
	Dan Parks Sydow
	1997
	
	Based on source code from:
	HelloView.cpp
	Copyright 1995 Be Incorporated, All Rights Reserved.
*/

#ifndef MY_DRAW_VIEW_H
#include "MyDrawView.h"
#endif

//class MyHelloApplication;

#ifndef MY_HELLO_WINDOW_H
#include "MyHelloWindow.h"
#endif

#ifndef MY_HELLO_WORLD_H
#include "MyHelloWorld.h"
#endif


MyDrawView::MyDrawView(BRect rect, char *name)
    : BView(rect, name, B_FOLLOW_ALL, B_WILL_DRAW)
{
   // *** NEW
   BPoint                leftTop(20.0, 50.0);
   color_control_layout  matrix = B_CELLS_16x16;
   long                  cellSide = 16;

   fColorControl = new BColorControl(leftTop, matrix, cellSide, "ColorControl");
   AddChild(fColorControl);
   // *** NEW

}


void MyDrawView::AttachedToWindow() 
{
    SetFont(be_bold_font); 
    SetFontSize(12);
}


void MyDrawView::Draw(BRect)
{
// get rid of framing view calls:
//   BRect frame = Bounds(); 
//   StrokeRect(frame);
// ** emptied out drawing tests and put this instruction in:
    MovePenTo(BPoint(20, 20));
    DrawString("Choose a color below, then move the cursor");
    MovePenTo(BPoint(20, 35));
    DrawString("outside of the color control and click the mouse button");
}


// *** NEW, from C4 ViewsMouseMessages project:

void MyDrawView::MouseDown(BPoint point)
{
   BRect      aRect(20.0, 330.0, 350.0, 340.0);
   rgb_color  userColorChoice;

   userColorChoice = fColorControl->ValueAsColor();

   SetHighColor(userColorChoice);

   FillRect(aRect, B_SOLID_HIGH);
}


