/*
	MyHelloWindow.cpp
	Dan Parks Sydow
	1997
	
	Based on source code from:
	HelloWindow.cpp
	Copyright 1995 Be Incorporated, All Rights Reserved.
*/

#ifndef _APPLICATION_H
#include <Application.h>
#endif
#ifndef MY_HELLO_WINDOW_H
#include "MyHelloWindow.h"
#endif


BRect       buttonBeep1Rect(20.0, 60.0, 110.0, 90.0);
const char* buttonBeep1Name = "Beep1";
const char* buttonBeep1Label = "Beep One";
// *** NEW
BRect       buttonBeep2Rect(130.0, 60.0, 220.0, 90.0);
const char* buttonBeep2Name = "Beep2";
const char* buttonBeep2Label = "Beep Two";
// *** NEW


MyHelloWindow::MyHelloWindow(BRect frame)
    : BWindow(frame, "My Hello", B_TITLED_WINDOW, B_NOT_RESIZABLE)
{
    frame.OffsetTo(B_ORIGIN);
    fMyView = new MyDrawView(frame, "MyDrawView");
    AddChild(fMyView);

	fButtonBeep1 = new BButton(	buttonBeep1Rect, 
								buttonBeep1Name, 
								buttonBeep1Label, 
								new BMessage(BUTTON_BEEP_1_MSG));
	fMyView->AddChild(fButtonBeep1);
// *** NEW
    fButtonBeep1->MakeDefault(true);
// *** NEW
    
// *** NEW
	fButtonBeep2 = new BButton(	buttonBeep2Rect, 
								buttonBeep2Name, 
								buttonBeep2Label, 
								new BMessage(BUTTON_BEEP_2_MSG));
	fMyView->AddChild(fButtonBeep2);
// *** NEW

    Show();
}


bool MyHelloWindow::QuitRequested()
{
    be_app->PostMessage(B_QUIT_REQUESTED);
    return(TRUE);
}


void MyHelloWindow::MessageReceived(BMessage* message)
{
// *** NEW
    bigtime_t  microseconds = 1000000;  // one second
// *** NEW

	switch(message->what)
	{
		case BUTTON_BEEP_1_MSG:
		  	beep();
		  	break;
		  	
// *** NEW
		case BUTTON_BEEP_2_MSG:
		  	beep();
   			snooze(microseconds);
 		  	beep();
			break;
// *** NEW
		
		default:
			BWindow::MessageReceived(message);
	}
}
