/*
	MyHelloWindow.cpp
	Dan Parks Sydow
	1997
	
	Based on source code from:
	HelloWindow.cpp
	Copyright 1995 Be Incorporated, All Rights Reserved.
*/

#ifndef _APPLICATION_H
#include <Application.h>
#endif
#ifndef MY_HELLO_WINDOW_H
#include "MyHelloWindow.h"
#endif

#define   MENU_BAR_HEIGHT   18.0


BRect       buttonBeepRect(15.0, 155.0, 110.0, 185.0);
const char* buttonBeepName = "Beep1";
const char* buttonBeepLabel = "Beep One";


MyHelloWindow::MyHelloWindow(BRect frame)
    : BWindow(frame, "My Hello", B_TITLED_WINDOW, B_NOT_ZOOMABLE)
{
//***** NEW   cut these two lines:
//      frame.OffsetTo(B_ORIGIN);
//      frame.top += MENU_BAR_HEIGHT + 1.0;
//  and replace with this one line to make a view that doesn't take up the whole window:
	frame.Set(130.0, MENU_BAR_HEIGHT + 10.0, 290.0, 190.0);
//***** NEW  end new

    fMyView = new MyDrawView(frame, "MyDrawView");
    AddChild(fMyView);

//****** NEW  adding button:
	fButtonBeep = new BButton(buttonBeepRect, buttonBeepName, 
							   buttonBeepLabel, new BMessage(BUTTON_BEEP_MSG));
// discuss the adding of a control directly to a window, as I do here, as opposed to 
// adding to a view. There's to be no drawing in the view that holds the control, so
// a view isn't needed. As you've seen, we *could* have a view and add the control to
// it. Just a different way of doing things.
//	fMyView->AddChild(fButtonBeep);  // use to add to view
	AddChild(fButtonBeep);           // use to add to window
    fButtonBeep->MakeDefault(true);
//******* NEW  end new

	BMenu		*menu;
	BMenuItem	*menuItem;
	BRect		menuBarRect;

  	// *ME: defining a rectangle to initially hold the menu bar
	menuBarRect.Set(0.0, 0.0, 32000.0, MENU_BAR_HEIGHT);
	fMenuBar = new BMenuBar(menuBarRect, "MenuBar");
	AddChild(fMenuBar);
	
	menu = new BMenu("Audio");
	fMenuBar->AddItem(menu);
	menu->AddItem(new BMenuItem("Beep Once", new BMessage(MENU_BEEP_1_MSG)));

    Show();

}


bool MyHelloWindow::QuitRequested()
{
    be_app->PostMessage(B_QUIT_REQUESTED);

    return(true);
}


void MyHelloWindow::MessageReceived(BMessage* message)
{

	switch(message->what)
	{
// ****** NEW new case section:
		case BUTTON_BEEP_MSG:
			beep();
 		  	break;
// ******* NEW  end new

		case MENU_BEEP_1_MSG:
			beep();
		  	break;

		default:
			BWindow::MessageReceived(message);
	}
}
