/*
	MyTextView.cpp
	Dan Parks Sydow
	1997
	
	Based on source code from:
	HelloView.cpp
	Copyright 1995 Be Incorporated, All Rights Reserved.
*/

#ifndef MY_TEXT_VIEW_H
#include "MyTextView.h"
#endif


// This is modified from MyDrawView, which invoked the BView constructor. 
// Here, invoke BTextView constructor rather than BView constructor.
MyTextView::MyTextView(BRect viewFrame, char *name, BRect textBounds)
//    : BView(rect, name, B_FOLLOW_ALL, B_WILL_DRAW)
    : BTextView(viewFrame, name, textBounds, B_FOLLOW_NONE, B_WILL_DRAW)
{
}



void MyTextView::MessageReceived(BMessage *message)
{
	switch (message->what) {
	
		case FONT_TEST_MSG:
			// ******* MY FONT TEST
			// changes the current text selection to a larger font and colors
			// the text red
   			rgb_color  		redColor = {255, 0, 0, 0};
			BFont			font;
			uint32			sameProperties;

			GetFontAndColor(&font, &sameProperties);
			font.SetSize(24.0);

			// don't need to specify a start and end. If SetStylable() wasn't
			// called, then all text in the view (now and later) gets changed.
			// If SetStylable(0 was called, then only the selected text gets
			// changed.
			SetFontAndColor(&font, B_FONT_ALL, &redColor);
			// ******* MY FONT TEST
			break;

		default:
			inherited::MessageReceived(message);
	}
}

