/*
	MyHelloWindow.cpp
	Dan Parks Sydow
	1997
	
	Based on source code from:
	HelloWindow.cpp
	Copyright 1995 Be Incorporated, All Rights Reserved.
*/

#ifndef _APPLICATION_H
#include <Application.h>
#endif
#ifndef MY_HELLO_WINDOW_H
#include "MyHelloWindow.h"
#endif

#define   MENU_BAR_HEIGHT   18.0


MyHelloWindow::MyHelloWindow(BRect frame)
    : BWindow(frame, "My Hello", B_TITLED_WINDOW, B_NOT_ZOOMABLE)
{
	frame.OffsetTo(B_ORIGIN);
	frame.top += MENU_BAR_HEIGHT + 1.0;

    fMyView = new MyDrawView(frame, "MyDrawView");
    AddChild(fMyView);

	BMenu		*menu;
	BMenuItem	*menuItem;
	BRect		menuBarRect;

	menuBarRect.Set(0.0, 0.0, 10000.0, MENU_BAR_HEIGHT);
	fMenuBar = new BMenuBar(menuBarRect, "MenuBar");
	AddChild(fMenuBar);
	
	menu = new BMenu("Text");
	fMenuBar->AddItem(menu);
	
	menu->AddItem(new BMenuItem("Test", new BMessage(TEST_MSG)));
	menu->AddItem(menuItem = new BMenuItem("Cut", new BMessage(B_CUT), 'X'));
	menuItem->SetTarget(NULL, this);
	menu->AddItem(menuItem = new BMenuItem("Copy", new BMessage(B_COPY), 'C'));
	menuItem->SetTarget(NULL, this);
	menu->AddItem(menuItem = new BMenuItem("Paste", new BMessage(B_PASTE), 'V'));
	menuItem->SetTarget(NULL, this);
	menu->AddItem(menuItem = new BMenuItem("Select All", new BMessage(B_SELECT_ALL), 'A'));
	menuItem->SetTarget(NULL, this);
	// ******* NEW
	menu->AddItem(menuItem = new BMenuItem("Add String", new BMessage(ADD_STR_MSG)));
//	menuItem->SetTarget(NULL, this);
	// ******* NEW

	Show();
}


bool MyHelloWindow::QuitRequested()
{
    be_app->PostMessage(B_QUIT_REQUESTED);

    return(true);
}


void MyHelloWindow::MessageReceived(BMessage* message)
{
	switch(message->what)
	{
		// ****** NEW
		// This was the TextViewEdit project from C8 **************
		case ADD_STR_MSG:

//  Plain text (by far the most common data kind) should 
//  be put under the name "text/plain" and of the type 
//  B_MIME_TYPE, without any trailing or terminating 
//  zero character.

//   status_t AddData(const char  *name, 
//                    type_code   type, 
//                    const void  *data, 
//                    ssize_t     numBytes, 
//                    bool        fixedSize = true, 
//                    int32       numItems = 1) 

/*
These functions put data in the BMessage. AddData() copies numBytes of data 
into the object, and assigns the data a name and a type code. It copies 
whatever the data pointer points to. For example, if you want to add a 
string of characters to the message, data should be the string pointer 
(char *). If you want to add only the string pointer, not the characters 
themselves, data should be a pointer to the pointer (char **). The assigned 
type must be a specific data type; it should not be B_ANY_TYPE.          

Ex:
   BMessage *msg = new BMessage(NUMBERS); 
   int32 x = 37; 
   int32 y = 223; 
   int32 z = 1049; 
   
   msg->AddInt32("primes", x); 
   msg->AddFloat("pi", 3.1416); 
   msg->AddInt32("primes", y); 
   msg->AddData("primes", B_INT32_TYPE, &z, sizeof(int32));
Note that entering other data between some of the elements of an array--in this case, "pi"--doesn't increment the 
array index. 
All elements in a named array must be of the same type; it's an error to try to mix types under the same name. 
When you call AddData() to place the first item in an array under a new name, you can provide it with two 
arguments, fixedSize and numItems, that will improve the object's efficiency when it adds subsequent items to the 
array. If the fixedSize flag is true, each item in the array must have the same number of bytes; if the flag is false, 
items can vary in size. For example, all items in an array of integers will be the same size, but the items in an 
array of strings are likely to have differing lengths. AddData() takes the numItems argument as a hint, an 
indication of how many items will be added to the array. It can more economically allocate memory for the items 
if it can anticipate how many there will be. 
When adding subsequent items to the array, AddData() ignores the fixedSize and numItems arguments; they're 
relevant only when the array is first established. You can call AddData() with these arguments to provide the 
necessary hints when setting up the array, then call other functions to add more items. 
You can also provide a numItems hint to AddFlat() when you call it to set up a new array. AddFlat() calls the 
object's IsFixedSize() function to discover whether all items in the array will be the same size. 
*/
 
			const char *theString = "Testing123";
			
/*
   			if ( be_clipboard->Lock() ) { 
       			BMessage  *clipMessage; 

       			be_clipboard->Clear(); 
       			clipMessage = be_clipboard->Data(); 
       			clipMessage->AddData("text/plain", B_MIME_TYPE, theString, strlen(theString));
       			be_clipboard->Commit(); 
       			be_clipboard->Unlock(); 
   			}
*/
   			be_clipboard->Lock(); 
       		be_clipboard->Clear(); 
       		
       		BMessage  *clipMessage; 

  			clipMessage = be_clipboard->Data(); 
       			
       		clipMessage->AddData("text/plain", B_MIME_TYPE, theString, strlen(theString));

       		be_clipboard->Commit(); 
       		be_clipboard->Unlock(); 
 
			break;
		// ****** NEW
		
		case TEST_MSG:
		  	beep();
		  	break;

		default:
			BWindow::MessageReceived(message);
	}
}
