/*
	MyHelloWindow.cpp
	Dan Parks Sydow
	1997
	
	Based on source code from:
	HelloWindow.cpp
	Copyright 1995 Be Incorporated, All Rights Reserved.
*/

#ifndef _APPLICATION_H
#include <Application.h>
#endif
#ifndef MY_HELLO_WINDOW_H
#include "MyHelloWindow.h"
#endif

#define   MENU_BAR_HEIGHT   18.0
#define   TEXT_INSET   		3.0


MyHelloWindow::MyHelloWindow(BRect frame)
    : BWindow(frame, "My Hello", B_TITLED_WINDOW, B_NOT_ZOOMABLE)
{
	frame.OffsetTo(B_ORIGIN);
	frame.top += MENU_BAR_HEIGHT + 1.0;

//    fMyView = new MyDrawView(frame, "MyDrawView");
//    AddChild(fMyView);

	BMenu		*menu;
	BMenuItem	*menuItem;
	BRect		menuBarRect;

	menuBarRect.Set(0.0, 0.0, 10000.0, MENU_BAR_HEIGHT);
	fMenuBar = new BMenuBar(menuBarRect, "MenuBar");
	AddChild(fMenuBar);
	
	menu = new BMenu("Text");
	fMenuBar->AddItem(menu);
	menu->AddItem(new BMenuItem("Test", new BMessage(MENU_FILE_SAVEAS_MSG)));

// *********  MOVED from MyDrawView *******
// This listing is very similar to the P08 ScrollViewText listing. I've removed that
// listing's comments. The comments below highlight the few changes made to that P08
// example project.

//  set the size of this rect  in the two new lines that follow these two declarations:
//  BRect  viewFrame(20.0, 20.0, 220.0, 80.0);
	BRect  viewFrame;
	BRect  textBounds;

// 	Next two lines are new -- just a little fiddling around here. The text view should be 
//  the size of the fMyView, less room for the vertical scrollbar. Set text view to the 
//  size of the main window view, fMyView (coordinates local to the view fMyView, not the 
//  window). Then subtract out the width of the scroll bar -- the scroll bar is added 
//  outside of the scroll view's right boundary
	viewFrame = Bounds();
// ****** NEW, to account for placing under menu bar
//	viewFrame.top = fMenuBar->Bounds().bottom + 1.0;

	viewFrame.top = MENU_BAR_HEIGHT + 1.0;
// **********
	viewFrame.right -= B_V_SCROLL_BAR_WIDTH;

	textBounds = viewFrame;
	textBounds.OffsetTo(B_ORIGIN);
	textBounds.InsetBy(TEXT_INSET, TEXT_INSET);
/*
	textBounds.left += TEXT_INSET;
	textBounds.right -= TEXT_INSET;
	textBounds.top += TEXT_INSET;
	textBounds.bottom -= TEXT_INSET;
*/

// 	Changed from B_FOLLOW_NONE to B_FOLLOW_ALL. When left at follow none,
//	growing the window resulted in the scroll bar being repeatedly drawn (and not being erased)
	fTextView = new BTextView(viewFrame, "MyTextView", textBounds,
           B_FOLLOW_ALL, B_WILL_DRAW);
           
// 	Changed from B_FOLLOW_NONE to B_FOLLOW_ALL. When left at follow none, the scrolling view 
//  doesn't grow with the window's growth
	fScrollView = new BScrollView("MyScrollView", fTextView, B_FOLLOW_ALL, 0, false, true);
	AddChild(fScrollView);
// **********



// *********
	// Create the save filepanel for this window
	
	savePanel = new BFilePanel(B_SAVE_PANEL, new BMessenger(this), NULL,
				B_FILE_NODE, false);
// *********

	Show();
}


bool MyHelloWindow::QuitRequested()
{
    be_app->PostMessage(B_QUIT_REQUESTED);

    return(true);
}


void MyHelloWindow::MessageReceived(BMessage* message)
{

	switch(message->what)
	{
//		case TEST_MSG:
//		  	beep();
//		  	break;

// *************
		case MENU_FILE_SAVEAS_MSG:
			savePanel->Show();
			break;
		case B_SAVE_REQUESTED:
			Save(message);
			break;
// *************	

		default:
			BWindow::MessageReceived(message);
	}
}


// ************* NEW ROUTINE FOLLOWS *************************
//
// TextWindow::Save
//
// Save the contents of the window.  The message specifies
// where to save it (see BFilePanel in the Storage Kit chapter
// of the Be Book).
//
status_t MyHelloWindow::Save(BMessage *message) {
	entry_ref ref;		// For the directory to save into
	status_t err;		// For the return code
	char *name;			// For the filename
	BPath path;			// For the pathname
	BEntry entry;		// Used to make the path
	FILE *f;			// Standard Posix file
	
	// If a NULL is passed for the message pointer, use
	// the value we've cached; this lets us do saves without
	// thinking.
	
	if (!message) {
		message = savemessage;
		if (!message) {
			return B_ERROR;
		}
	}
	
	// Peel the entry_ref and name of the directory and
	// file out of the message.
	
	if (err=message->FindRef("directory", &ref) != B_OK) {
		return err;
	}
	if (err=message->FindString("name", &name) != B_OK) {
		return err;
	}
	
	// Take the directory and create a pathname out of it
	
	if (err=entry.SetTo(&ref) != B_OK) {
		return err;
	}
	entry.GetPath(&path);		// Create a pathname for the directory
	path.Append(name);			// Tack on the filename
	
	// Now we can save the file.
	
	if (!(f = fopen(path.Path(), "w"))) {
		return B_ERROR;
	}
	
	err = fwrite(fTextView->Text(), 1, fTextView->TextLength(), f);
	fclose(f);
	if (err >= 0) {
		SetTitle(name);
//		saveitem->SetEnabled(true);
		if (savemessage != message) {
			if (savemessage) {
				delete savemessage;
			}
			savemessage = new BMessage(message);
		}
	}
	return err;
}

